/*
 * generated by Xtext 2.11.0
 */
package com.mncml.implementation.pogo.serializer;

import com.google.inject.Inject;
import com.mncml.implementation.pogo.services.SimulatorDslGrammarAccess;
import java.util.List;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.IGrammarAccess;
import org.eclipse.xtext.RuleCall;
import org.eclipse.xtext.nodemodel.INode;
import org.eclipse.xtext.serializer.analysis.GrammarAlias.AbstractElementAlias;
import org.eclipse.xtext.serializer.analysis.GrammarAlias.GroupAlias;
import org.eclipse.xtext.serializer.analysis.GrammarAlias.TokenAlias;
import org.eclipse.xtext.serializer.analysis.ISyntacticSequencerPDAProvider.ISynNavigable;
import org.eclipse.xtext.serializer.analysis.ISyntacticSequencerPDAProvider.ISynTransition;
import org.eclipse.xtext.serializer.sequencer.AbstractSyntacticSequencer;

@SuppressWarnings("all")
public class SimulatorDslSyntacticSequencer extends AbstractSyntacticSequencer {

	protected SimulatorDslGrammarAccess grammarAccess;
	protected AbstractElementAlias match_TangoSimLib___BehavioursKeyword_6_0_LeftCurlyBracketKeyword_6_1_RightCurlyBracketKeyword_6_3__q;
	protected AbstractElementAlias match_TangoSimLib___DataSimulationsKeyword_5_0_LeftCurlyBracketKeyword_5_1_RightCurlyBracketKeyword_5_3__q;
	protected AbstractElementAlias match_TangoSimLib___OverrideKeyword_7_0_LeftCurlyBracketKeyword_7_1_RightCurlyBracketKeyword_7_3__q;
	
	@Inject
	protected void init(IGrammarAccess access) {
		grammarAccess = (SimulatorDslGrammarAccess) access;
		match_TangoSimLib___BehavioursKeyword_6_0_LeftCurlyBracketKeyword_6_1_RightCurlyBracketKeyword_6_3__q = new GroupAlias(false, true, new TokenAlias(false, false, grammarAccess.getTangoSimLibAccess().getBehavioursKeyword_6_0()), new TokenAlias(false, false, grammarAccess.getTangoSimLibAccess().getLeftCurlyBracketKeyword_6_1()), new TokenAlias(false, false, grammarAccess.getTangoSimLibAccess().getRightCurlyBracketKeyword_6_3()));
		match_TangoSimLib___DataSimulationsKeyword_5_0_LeftCurlyBracketKeyword_5_1_RightCurlyBracketKeyword_5_3__q = new GroupAlias(false, true, new TokenAlias(false, false, grammarAccess.getTangoSimLibAccess().getDataSimulationsKeyword_5_0()), new TokenAlias(false, false, grammarAccess.getTangoSimLibAccess().getLeftCurlyBracketKeyword_5_1()), new TokenAlias(false, false, grammarAccess.getTangoSimLibAccess().getRightCurlyBracketKeyword_5_3()));
		match_TangoSimLib___OverrideKeyword_7_0_LeftCurlyBracketKeyword_7_1_RightCurlyBracketKeyword_7_3__q = new GroupAlias(false, true, new TokenAlias(false, false, grammarAccess.getTangoSimLibAccess().getOverrideKeyword_7_0()), new TokenAlias(false, false, grammarAccess.getTangoSimLibAccess().getLeftCurlyBracketKeyword_7_1()), new TokenAlias(false, false, grammarAccess.getTangoSimLibAccess().getRightCurlyBracketKeyword_7_3()));
	}
	
	@Override
	protected String getUnassignedRuleCallToken(EObject semanticObject, RuleCall ruleCall, INode node) {
		return "";
	}
	
	
	@Override
	protected void emitUnassignedTokens(EObject semanticObject, ISynTransition transition, INode fromNode, INode toNode) {
		if (transition.getAmbiguousSyntaxes().isEmpty()) return;
		List<INode> transitionNodes = collectNodes(fromNode, toNode);
		for (AbstractElementAlias syntax : transition.getAmbiguousSyntaxes()) {
			List<INode> syntaxNodes = getNodesFor(transitionNodes, syntax);
			if (match_TangoSimLib___BehavioursKeyword_6_0_LeftCurlyBracketKeyword_6_1_RightCurlyBracketKeyword_6_3__q.equals(syntax))
				emit_TangoSimLib___BehavioursKeyword_6_0_LeftCurlyBracketKeyword_6_1_RightCurlyBracketKeyword_6_3__q(semanticObject, getLastNavigableState(), syntaxNodes);
			else if (match_TangoSimLib___DataSimulationsKeyword_5_0_LeftCurlyBracketKeyword_5_1_RightCurlyBracketKeyword_5_3__q.equals(syntax))
				emit_TangoSimLib___DataSimulationsKeyword_5_0_LeftCurlyBracketKeyword_5_1_RightCurlyBracketKeyword_5_3__q(semanticObject, getLastNavigableState(), syntaxNodes);
			else if (match_TangoSimLib___OverrideKeyword_7_0_LeftCurlyBracketKeyword_7_1_RightCurlyBracketKeyword_7_3__q.equals(syntax))
				emit_TangoSimLib___OverrideKeyword_7_0_LeftCurlyBracketKeyword_7_1_RightCurlyBracketKeyword_7_3__q(semanticObject, getLastNavigableState(), syntaxNodes);
			else acceptNodes(getLastNavigableState(), syntaxNodes);
		}
	}

	/**
	 * Ambiguous syntax:
	 *     ('behaviours' '{' '}')?
	 *
	 * This ambiguous syntax occurs at:
	 *     (rule start) 'TangoSimLib' 'for' '{' ('dataSimulations' '{' '}')? (ambiguity) 'override' '{' overrideClass+=OverrideClass
	 *     (rule start) 'TangoSimLib' 'for' '{' ('dataSimulations' '{' '}')? (ambiguity) ('override' '{' '}')? '}' (rule start)
	 *     dataSimulations+=DataSimulation '}' (ambiguity) 'override' '{' overrideClass+=OverrideClass
	 *     dataSimulations+=DataSimulation '}' (ambiguity) ('override' '{' '}')? '}' (rule end)
	 *     refferedPogoDeviceClass=[PogoDeviceClass|QualifiedName] '{' ('dataSimulations' '{' '}')? (ambiguity) 'override' '{' overrideClass+=OverrideClass
	 *     refferedPogoDeviceClass=[PogoDeviceClass|QualifiedName] '{' ('dataSimulations' '{' '}')? (ambiguity) ('override' '{' '}')? '}' (rule end)
	 */
	protected void emit_TangoSimLib___BehavioursKeyword_6_0_LeftCurlyBracketKeyword_6_1_RightCurlyBracketKeyword_6_3__q(EObject semanticObject, ISynNavigable transition, List<INode> nodes) {
		acceptNodes(transition, nodes);
	}
	
	/**
	 * Ambiguous syntax:
	 *     ('dataSimulations' '{' '}')?
	 *
	 * This ambiguous syntax occurs at:
	 *     (rule start) 'TangoSimLib' 'for' '{' (ambiguity) 'behaviours' '{' commandSimulations+=CommandSimulation
	 *     (rule start) 'TangoSimLib' 'for' '{' (ambiguity) ('behaviours' '{' '}')? 'override' '{' overrideClass+=OverrideClass
	 *     (rule start) 'TangoSimLib' 'for' '{' (ambiguity) ('behaviours' '{' '}')? ('override' '{' '}')? '}' (rule start)
	 *     refferedPogoDeviceClass=[PogoDeviceClass|QualifiedName] '{' (ambiguity) 'behaviours' '{' commandSimulations+=CommandSimulation
	 *     refferedPogoDeviceClass=[PogoDeviceClass|QualifiedName] '{' (ambiguity) ('behaviours' '{' '}')? 'override' '{' overrideClass+=OverrideClass
	 *     refferedPogoDeviceClass=[PogoDeviceClass|QualifiedName] '{' (ambiguity) ('behaviours' '{' '}')? ('override' '{' '}')? '}' (rule end)
	 */
	protected void emit_TangoSimLib___DataSimulationsKeyword_5_0_LeftCurlyBracketKeyword_5_1_RightCurlyBracketKeyword_5_3__q(EObject semanticObject, ISynNavigable transition, List<INode> nodes) {
		acceptNodes(transition, nodes);
	}
	
	/**
	 * Ambiguous syntax:
	 *     ('override' '{' '}')?
	 *
	 * This ambiguous syntax occurs at:
	 *     (rule start) 'TangoSimLib' 'for' '{' ('dataSimulations' '{' '}')? ('behaviours' '{' '}')? (ambiguity) '}' (rule start)
	 *     commandSimulations+=CommandSimulation ',' '}' (ambiguity) '}' (rule end)
	 *     commandSimulations+=CommandSimulation '}' (ambiguity) '}' (rule end)
	 *     dataSimulations+=DataSimulation '}' ('behaviours' '{' '}')? (ambiguity) '}' (rule end)
	 *     refferedPogoDeviceClass=[PogoDeviceClass|QualifiedName] '{' ('dataSimulations' '{' '}')? ('behaviours' '{' '}')? (ambiguity) '}' (rule end)
	 */
	protected void emit_TangoSimLib___OverrideKeyword_7_0_LeftCurlyBracketKeyword_7_1_RightCurlyBracketKeyword_7_3__q(EObject semanticObject, ISynNavigable transition, List<INode> nodes) {
		acceptNodes(transition, nodes);
	}
	
}
